package com.afp.ordermanagement.reactivekafkaservice;

import com.afp.ordermanagement.service.OrderService;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.clients.producer.RecordMetadata;
import org.reactivestreams.Publisher;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
import reactor.kafka.sender.KafkaSender;
import reactor.kafka.sender.SenderOptions;
import reactor.kafka.sender.SenderRecord;
import reactor.kafka.sender.SenderResult;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CountDownLatch;


@Service
@Slf4j
public class Sender {



    @Autowired
    private KafkaSender<String, String> kafkaEventProducer;


    private static final String ORDER_TOPIC = "orders";


    public void sendOrderIdToWarehouse(String id) {
        log.info(String.format("##### -> Sender sending message: %s ", id));
//        sendMessage(ORDER_TOPIC, id, id);
        ProducerRecord<String, String> record = new ProducerRecord<>(ORDER_TOPIC, id);
        Flux<SenderResult<String>> working = kafkaEventProducer.send(Mono.just(SenderRecord.create(record, id)))
                .doOnError(throwable -> System.out.println(throwable))
                .doOnNext(uuidSenderResult -> {
                    if (null != uuidSenderResult.exception()) {
                        System.out.println("working");
                    }
                });
        working.doOnError(throwable -> log.error("some error")).subscribe();
    }


    public void sendUpdatedStatus(String id, String status) {
        log.info(String.format("Sender sending updated status for ordernumber: %s", id));
        ProducerRecord<String, String> stat = new ProducerRecord<>(ORDER_TOPIC, status);

    }


}
